record R {
  var x: int = 0;
  proc init() {
    this.x = 0;
    writeln("init (default)");
  }
  proc init(arg:int) {
    this.x = arg;
    writeln("init ", arg, " ", arg);
  }
  proc init=(other: R) {
    this.x = other.x;
    writeln("init= ", other.x);
  }
}
operator R.=(ref lhs:R, rhs:R) {
  writeln("lhs ", lhs.x, " = rhs ", rhs.x);
  lhs.x = rhs.x;
}
proc makeRecord() {
  return new R(); // creates a new R record
}

proc acceptWithIn(in arg) { }

proc elideCopy() {
  var x = makeRecord();
  acceptWithIn(x); // copy to 'in arg' is elided
                   // because 'x' is not used again
  writeln("block ending");
}
elideCopy();

proc noElideCopy() {
  var x = makeRecord();
  acceptWithIn(x); // copy to 'in arg' remains because 'x' is used again
  writeln(x); // 'x' used here
  writeln("block ending");
}
noElideCopy();
