proc splitInitsBecausePathKnown(type T) {
  var x: int;
  select T {
    when int {
      // split initialization occurs here when T==int
      x = 1; 
    }
    when string {
      //compiler ignores this block when T==int
      writeln("T==string");
    }
  }
  writeln(x);
}
proc noSplitInitBecausePathUnknown(arg: int) {
  var x: int;
  select arg {
    when 0 {
      // no split init, not all paths return, throw, or initialize
      x = 1; 
    }
    when 1 {
      // this block not ignored by compiler
      // arg value unknown at compile-time
      writeln("no initialization");
    } 
  }
  writeln(x);
}
proc main() {
  splitInitsBecausePathKnown(int);
  noSplitInitBecausePathUnknown(0);
}
    
