proc noSplitInitMissingOtherwise(arg: int) {
  var x: int;
  select arg {
    when 0 {
      // no split init, not all paths return, throw, or initialize
      // consider path taken when arg==2
      x = 1; 
    }
    when 1 {
      x = 2; 
    } 
    // since this select statement does not have an `otherwise`,
    // the compiler considers it equivalent to an empty `otherwise`:
    // otherwise { }
  }
  writeln(x);
}
proc splitInitHasOtherwise(arg: int) {
  var x: int;
  select arg {
    when 0 {
      // split init will occur here
      x = 1;
    }
    when 1 {
      x = 2;
    } 
    otherwise {
      // now all paths initialize, return, or throw.
      return; 
    }
  }
  writeln(x);
}
proc main() {
  noSplitInitMissingOtherwise(1);
  splitInitHasOtherwise(2);
}
