"""
AUTOGENERATED FILE - DO NOT EDIT
"""

import typing

class Context:
    def introspect_parsed_files(self) -> typing.List[str]:
        """
        Inspect the list of files that have been parsed by the Context
        """
        ...

    def track_errors(self) -> ErrorManager:
        """
        Return a context manager that tracks errors emitted by this Context
        """
        ...

    def _get_pyi_file(self) -> str:
        """
        Generate a stub file for the Chapel AST nodes
        """
        ...

    def parse(self, arg0: str) -> typing.List[AstNode]:
        """
        Parse a top-level AST node from the given file
        """
        ...

    def set_module_paths(self, arg0: typing.List[str], arg1: typing.List[str]) -> None:
        """
        Set the module path arguments to the given lists of module paths and filenames
        """
        ...

    def is_bundled_path(self, arg0: str) -> bool:
        """
        Check if the given file path is within the bundled (built-in) Chapel files
        """
        ...

    def advance_to_next_revision(self, arg0: bool) -> None:
        """
        Advance the context to the next revision
        """
        ...

    def get_file_text(self, arg0: str) -> str:
        """
        Get the text of the file at the given path
        """
        ...


class Location:
    def start(self) -> typing.Tuple[int, int]:
        """
        Get the line-column pair where this Location starts
        """
        ...

    def end(self) -> typing.Tuple[int, int]:
        """
        Get the line-column pair where this Location ends
        """
        ...

    def path(self) -> str:
        """
        Get the file path of this Location
        """
        ...

    def clamp_left(self, arg0: Location) -> Location:
        """
        Get a new Location removes the left part of the current Location based on another Location
        """
        ...


class Scope:
    def modules_named_in_use_or_import(self) -> typing.List[Module]:
        """
        Get the modules that were named in use or import statements directly within this scope
        """
        ...

    def parent_scope(self) -> typing.Optional[Scope]:
        """
        Get the parent (outer) scope of this scope
        """
        ...

    def visible_nodes(self) -> typing.List[typing.Tuple[str, typing.List[AstNode]]]:
        """
        Get the nodes corresponding to declarations exported from this scope
        """
        ...


class Error:
    def code_snippets(self) -> typing.List[typing.Tuple[Location, typing.List[Location]]]:
        """
        Get the locations of code snippets printed by this error
        """
        ...

    def location(self) -> Location:
        """
        Get the location at which this error occurred
        """
        ...

    def message(self) -> str:
        """
        Retrieve the contents of this error message
        """
        ...

    def notes(self) -> typing.List[typing.Tuple[Location, str]]:
        """
        Get the locations and text of additional notes printed by this error
        """
        ...

    def kind(self) -> str:
        """
        Retrieve the kind ('error', 'warning') of this type of error
        """
        ...

    def type(self) -> typing.Optional[str]:
        """
        Retrieve the unique name of this type of error
        """
        ...


class ErrorManager:
    def __enter__(self) -> typing.Any:
        """
        The context manager 'enter' method for this ErrorManager object
        """
        ...

    def __exit__(self, arg0: typing.Any, arg1: typing.Any, arg2: typing.Any) -> None:
        """
        The context manager 'enter' method for this ErrorManager object
        """
        ...


class ResolvedExpression:
    def most_specific_candidate(self) -> typing.Optional[MostSpecificCandidate]:
        """
        If this node is a call, return the most specific overload selected by call resolution.
        """
        ...

    def type(self) -> typing.Optional[typing.Tuple[str, typing.Optional[ChapelType], typing.Optional[Param]]]:
        """
        Retrieve the type of the expression.
        """
        ...


class MostSpecificCandidate:
    def function(self) -> TypedSignature:
        """
        Get the signature of the function called by this candidate.
        """
        ...

    def formal_actual_mapping(self) -> typing.List[int]:
        """
        Get the index of the function's formal for each of the call's actuals.
        """
        ...


class TypedSignature:
    def formal_type(self, arg0: int) -> typing.Optional[typing.Tuple[str, typing.Optional[ChapelType], typing.Optional[Param]]]:
        """
        Get the type of the nth formal of this function signature
        """
        ...

    def is_instantiation(self) -> bool:
        """
        Check if this function is an instantiation of a generic function
        """
        ...

    def ast(self) -> typing.Optional[AstNode]:
        """
        Get the AST from which this function signature is computed
        """
        ...


class Param:
    pass

class BoolParam(Param):
    def value(self) -> bool:
        """
        Get the value of this boolean Param
        """
        ...


class EnumParam(Param):
    def value(self) -> AstNode:
        """
        Get the value of this enum Param
        """
        ...


class IntParam(Param):
    def value(self) -> int:
        """
        Get the value of this integer Param
        """
        ...


class StringParam(Param):
    def value(self) -> str:
        """
        Get the value of this string Param
        """
        ...


class ChapelType:
    pass

class CompositeType(DeclaredType):
    def decl(self) -> typing.Optional[AstNode]:
        """
        Get the chpl::uast::AstNode that declares this CompositeType
        """
        ...


class AstNode:
    def __iter__(self) -> typing.Iterator[AstNode]:
        ...

    def dump(self) -> None:
        """
        Dump the internal representation of the given AST node
        """
        ...

    def tag(self) -> str:
        """
        Get a string representation of the AST node's type
        """
        ...

    def attribute_group(self) -> typing.Optional[AttributeGroup]:
        """
        Get the attribute group, if any, associated with this node
        """
        ...

    def location(self) -> Location:
        """
        Get the location of this AST node in its file
        """
        ...

    def parent(self) -> typing.Optional[AstNode]:
        """
        Get the parent node of this AST node
        """
        ...

    def parent_symbol(self) -> typing.Optional[AstNode]:
        """
        Get the parent symbol of this AST node (e.g., module, variable, etc.)
        """
        ...

    def pragmas(self) -> typing.Set[str]:
        """
        Get the pragmas of this AST node
        """
        ...

    def unique_id(self) -> str:
        """
        Get a unique identifier for this AST node
        """
        ...

    def scope(self) -> typing.Optional[Scope]:
        """
        Get the scope for this AST node
        """
        ...

    def type(self) -> typing.Optional[typing.Tuple[str, typing.Optional[ChapelType], typing.Optional[Param]]]:
        """
        Get the type of this AST node, as a 3-tuple of (kind, type, param).
        """
        ...

    def called_fn(self) -> typing.Optional[AstNode]:
        """
        Get the function being invoked by this node
        """
        ...

    def resolve(self) -> typing.Optional[ResolvedExpression]:
        """
        Perform resolution on code surrounding this node to determine its type and other information.
        """
        ...

    def scope_resolve(self) -> typing.Optional[ResolvedExpression]:
        """
        Perform scope resolution on code surrounding this node to retrieve its to-ID and collect errors.
        """
        ...

    def resolve_via(self, arg0: TypedSignature) -> typing.Optional[ResolvedExpression]:
        """
        Use a given function's type information to determine the information of this node.
        """
        ...

    def block_header(self) -> typing.Optional[Location]:
        """
        Get the header Location of this block-like AstNode node
        """
        ...

    def curly_braces_location(self) -> typing.Optional[Location]:
        """
        Get the Location of the curly braces of this AstNode node
        """
        ...

    def parenth_location(self) -> typing.Optional[Location]:
        """
        Get the Location of the parentheses of this AstNode node
        """
        ...


class AnonFormal(AstNode):
    def intent(self) -> str:
        """
        Get the intent for this AnonFormal node
        """
        ...

    def type_expression(self) -> typing.Optional[AstNode]:
        """
        Get the type expression for this AnonFormal node
        """
        ...


class As(AstNode):
    def symbol(self) -> AstNode:
        """
        Get the symbol for this As node
        """
        ...

    def rename(self) -> AstNode:
        """
        Get the rename for this As node
        """
        ...


class Array(AstNode):
    def exprs(self) -> typing.Iterator[AstNode]:
        """
        Get the expressions from this Array node
        """
        ...

    def has_trailing_comma(self) -> bool:
        """
        Check if this Array node has a trailing comma
        """
        ...

    def is_associative(self) -> bool:
        """
        Check if this Array node is associative
        """
        ...


class Attribute(AstNode):
    def name(self) -> str:
        """
        Get the name of this Attribute node
        """
        ...


class AttributeGroup(AstNode):
    def get_attribute_named(self, arg0: str) -> typing.Optional[AstNode]:
        """
        Get the attribute with a particular name, if any
        """
        ...

    def is_unstable(self) -> bool:
        """
        Check if this AttributeGroup contains the 'unstable' attribute
        """
        ...

    def is_deprecated(self) -> bool:
        """
        Check if this AttributeGroup contains the 'deprecated' attribute
        """
        ...


class Break(AstNode):
    def target(self) -> typing.Optional[Identifier]:
        """
        Get the target from this Break node
        """
        ...


class Catch(AstNode):
    def target(self) -> typing.Optional[Variable]:
        """
        Get the error from this Catch node
        """
        ...

    def body(self) -> Block:
        """
        Get the body from this Catch node
        """
        ...

    def has_parens_around_error(self) -> bool:
        """
        Check if this Catch uses parentheses
        """
        ...


class Cobegin(AstNode):
    def with_clause(self) -> typing.Optional[WithClause]:
        """
        Get the WithClause from this Cobegin node
        """
        ...

    def task_bodies(self) -> typing.Iterator[AstNode]:
        """
        Get tasks from this Cobegin node
        """
        ...


class Conditional(AstNode):
    def condition(self) -> AstNode:
        """
        Get the condition of this Conditional node
        """
        ...

    def else_block(self) -> typing.Optional[Block]:
        """
        Get the else block of this Conditional node or None if no else block
        """
        ...

    def is_expression_level(self) -> bool:
        """
        Checks if this Conditional node is expression-level
        """
        ...

    def then_block(self) -> Block:
        """
        Get the then block of this Conditional node
        """
        ...


class Comment(AstNode):
    def text(self) -> str:
        """
        Get the text from this Comment node
        """
        ...


class Continue(AstNode):
    def target(self) -> typing.Optional[Identifier]:
        """
        Get the target from this Continue node
        """
        ...


class Delete(AstNode):
    def exprs(self) -> typing.Iterator[AstNode]:
        """
        Get the expressions from this Delete node
        """
        ...


class Domain(AstNode):
    def exprs(self) -> typing.Iterator[AstNode]:
        """
        Get the expressions from this Domain node
        """
        ...

    def used_curly_braces(self) -> bool:
        """
        Check if the Domain node used curly braces
        """
        ...


class Dot(AstNode):
    def field(self) -> str:
        """
        Get the field accessed in the Dot node
        """
        ...

    def field_location(self) -> Location:
        """
        Get the textual location of the Dot node's field expression
        """
        ...

    def receiver(self) -> AstNode:
        """
        Get the receiver of the Dot node
        """
        ...

    def to_node(self) -> typing.Optional[AstNode]:
        """
        Get the AST node that this Dot node refers to
        """
        ...


class ExternBlock(AstNode):
    def code(self) -> str:
        """
        Get C code of this ExternBlock node
        """
        ...


class FunctionSignature(AstNode):
    def formals(self) -> typing.Iterator[Decl]:
        """
        Get the formals for this FunctionSignature node
        """
        ...

    def is_parenless(self) -> bool:
        """
        Check if this FunctionSignature node is parenless
        """
        ...

    def kind(self) -> str:
        """
        Get the kind of this FunctionSignature node
        """
        ...

    def return_intent(self) -> str:
        """
        Get the return intent of this FunctionSignature node
        """
        ...

    def return_type(self) -> typing.Optional[AstNode]:
        """
        Get the return type for this FunctionSignature node
        """
        ...

    def this_formal(self) -> typing.Optional[Formal]:
        """
        Get the this formal for this FunctionSignature node
        """
        ...

    def throws(self) -> bool:
        """
        Check if this FunctionSignature node is marked throws
        """
        ...


class Implements(AstNode):
    def interface_name(self) -> str:
        """
        Get the interface name of this Implements node
        """
        ...

    def type_ident(self) -> typing.Optional[Identifier]:
        """
        Get the type identifier from this Implements node
        """
        ...

    def interface_expr(self) -> AstNode:
        """
        Get the interface expression from this Implements node
        """
        ...

    def is_expression_level(self) -> bool:
        """
        Check if this Implements node is expression level
        """
        ...


class Identifier(AstNode):
    def name(self) -> str:
        """
        Get the name of this Identifier node
        """
        ...

    def to_node(self) -> typing.Optional[AstNode]:
        """
        Get the AST node that this Identifier node refers to
        """
        ...


class Import(AstNode):
    def visibility(self) -> str:
        """
        Get the visibility of this Import node
        """
        ...

    def visibility_clauses(self) -> typing.Iterator[VisibilityClause]:
        """
        Get the visibility clauses of this Import node
        """
        ...


class Include(AstNode):
    def name(self) -> str:
        """
        Get the name of this Include node
        """
        ...

    def is_prototype(self) -> bool:
        """
        Check if this Include node is for a prototype module
        """
        ...

    def visibility(self) -> str:
        """
        Get the visibility of this Include node
        """
        ...


class Init(AstNode):
    def target(self) -> Identifier:
        """
        Get the target of this Init node
        """
        ...


class Label(AstNode):
    def loop(self) -> Loop:
        """
        Get the loop this Label node is attached to
        """
        ...

    def name(self) -> str:
        """
        Get the name of this Label node
        """
        ...


class New(AstNode):
    def management(self) -> str:
        """
        Get the management style for this New node
        """
        ...

    def type_expression(self) -> AstNode:
        """
        Get the type expression for this New node
        """
        ...


class Range(AstNode):
    def lower_bound(self) -> typing.Optional[AstNode]:
        """
        Get the lower bound of this Range node
        """
        ...

    def op_kind(self) -> str:
        """
        Get the op kind of this Range node
        """
        ...

    def upper_bound(self) -> typing.Optional[AstNode]:
        """
        Get the upper bound of this Range node
        """
        ...


class Require(AstNode):
    def exprs(self) -> typing.Iterator[AstNode]:
        """
        Get the expressions of this Require node
        """
        ...


class Return(AstNode):
    def value(self) -> typing.Optional[AstNode]:
        """
        Get the expression returned by this Return node
        """
        ...


class Select(AstNode):
    def exprs(self) -> AstNode:
        """
        Get the expression of this Select node
        """
        ...

    def when_stmts(self) -> typing.Iterator[When]:
        """
        Get the When statements of this Select node
        """
        ...


class Throw(AstNode):
    def error_expression(self) -> AstNode:
        """
        Get the expression thrown by this Throw node
        """
        ...


class Try(AstNode):
    def body(self) -> Block:
        """
        Get the body of this Try node
        """
        ...

    def handlers(self) -> typing.Iterator[Catch]:
        """
        Get the Catch node handlers of this Try node
        """
        ...

    def is_expression_level(self) -> bool:
        """
        Check if this Try node is expression level
        """
        ...

    def is_try_bang(self) -> bool:
        """
        Check if this Try node is a 'try!'
        """
        ...


class Use(AstNode):
    def visibility(self) -> str:
        """
        Get the visibility of this Use node
        """
        ...

    def visibility_clauses(self) -> typing.Iterator[VisibilityClause]:
        """
        Get the visibility clauses of this Use node
        """
        ...


class VisibilityClause(AstNode):
    def symbol(self) -> AstNode:
        """
        Get the symbol referenced by this VisibilityClause node
        """
        ...


class WithClause(AstNode):
    def exprs(self) -> typing.Iterator[AstNode]:
        """
        Get the expressions of this WithClause node
        """
        ...


class Yield(AstNode):
    def value(self) -> typing.Optional[AstNode]:
        """
        Get the expression yielded by this Yield node
        """
        ...


class SimpleBlockLike(AstNode):
    def block_style(self) -> str:
        """
        Get the block style of this SimpleBlockLike node
        """
        ...

    def stmts(self) -> typing.Iterator[AstNode]:
        """
        Get the statements contained in this SimpleBlockLike.
        """
        ...


class Begin(SimpleBlockLike):
    def with_clause(self) -> typing.Optional[WithClause]:
        """
        Get the WithClause of this Begin node
        """
        ...


class Local(SimpleBlockLike):
    def condition(self) -> typing.Optional[AstNode]:
        """
        Get the condition of this Local node
        """
        ...


class Manage(SimpleBlockLike):
    def managers(self) -> typing.Iterator[AstNode]:
        """
        Get the managers of this Manage node
        """
        ...


class On(SimpleBlockLike):
    def destination(self) -> AstNode:
        """
        Get the destination of this On node
        """
        ...


class Serial(SimpleBlockLike):
    def condition(self) -> typing.Optional[AstNode]:
        """
        Get the condition of this Serial node
        """
        ...


class When(AstNode):
    def block_style(self) -> str:
        """
        Get the block style of this When node
        """
        ...

    def body(self) -> Block:
        """
        Get the body of this When node
        """
        ...

    def case_exprs(self) -> typing.Iterator[AstNode]:
        """
        Get the case expressions of this When node
        """
        ...

    def is_otherwise(self) -> bool:
        """
        Check if this When node uses the otherwise keyword
        """
        ...


class Loop(AstNode):
    def block_style(self) -> str:
        """
        Get the block style of this Loop node
        """
        ...

    def body(self) -> AstNode:
        """
        Get the body of this Loop node
        """
        ...

    def header_location(self) -> typing.Optional[Location]:
        """
        Get the Location of this Loop node's header
        """
        ...


class DoWhile(Loop):
    def condition(self) -> AstNode:
        """
        Get the condition of this DoWhole node
        """
        ...


class While(Loop):
    def condition(self) -> AstNode:
        """
        Get the condition of this While node
        """
        ...


class IndexableLoop(Loop):
    def index(self) -> typing.Optional[Decl]:
        """
        Get the index of this IndexableLoop node
        """
        ...

    def is_expression_level(self) -> bool:
        """
        Check if this IndexableLoop node is expression level
        """
        ...

    def iterand(self) -> AstNode:
        """
        Get the iterand of this IndexableLoop node
        """
        ...

    def with_clause(self) -> typing.Optional[WithClause]:
        """
        Get the WithClause of this IndexableLoop node
        """
        ...


class BracketLoop(IndexableLoop):
    def is_maybe_array_type(self) -> bool:
        """
        Check if this BracketLoop node may actually be a type
        """
        ...


class For(IndexableLoop):
    def is_param(self) -> bool:
        """
        Check if this For node is a param
        """
        ...


class BoolLiteral(Literal):
    def value(self) -> bool:
        """
        Get the value of this BoolLiteral node
        """
        ...


class ImagLiteral(Literal):
    def text(self) -> str:
        """
        Get the value of this ImagLiteral node
        """
        ...


class IntLiteral(Literal):
    def text(self) -> str:
        """
        Get the value of this IntLiteral node
        """
        ...


class RealLiteral(Literal):
    def text(self) -> str:
        """
        Get the value of this RealLiteral node
        """
        ...


class UintLiteral(Literal):
    def text(self) -> str:
        """
        Get the value of this UintLiteral node
        """
        ...


class StringLikeLiteral(Literal):
    def value(self) -> str:
        """
        Get the value of this StringLikeLiteral node
        """
        ...


class Call(AstNode):
    def actuals(self) -> typing.Iterator[AstNode]:
        """
        Get the arguments to this Call node
        """
        ...

    def num_actuals(self) -> int:
        """
        Get the number of actuals for this Call node
        """
        ...

    def actual(self, arg0: int) -> AstNode:
        """
        Get the n'th actual of this Call node
        """
        ...

    def called_expression(self) -> AstNode:
        """
        Get the expression invoked by this Call node
        """
        ...

    def formal_actual_mapping(self) -> typing.List[int]:
        """
        Get the index of the function's formal for each of the call's actuals.
        """
        ...


class FnCall(Call):
    def used_square_brackets(self) -> bool:
        """
        Check if this FnCall was made using square brackets
        """
        ...


class OpCall(Call):
    def is_binary_op(self) -> bool:
        """
        Check if this OpCall node is a binary op
        """
        ...

    def is_unary_op(self) -> bool:
        """
        Check if this OpCall node is an unary op
        """
        ...

    def op(self) -> str:
        """
        Get the op string for this OpCall node
        """
        ...


class PrimCall(Call):
    def prim(self) -> str:
        """
        Get the primitive name for this PrimCall node
        """
        ...


class Reduce(Call):
    def iterand(self) -> AstNode:
        """
        Get the iterand for this Reduce node
        """
        ...

    def op(self) -> AstNode:
        """
        Get the op for this Reduce node
        """
        ...


class Scan(Call):
    def iterand(self) -> AstNode:
        """
        Get the iterand for this Scan node
        """
        ...

    def op(self) -> AstNode:
        """
        Get the op for this Scan node
        """
        ...


class Decl(AstNode):
    def linkage(self) -> str:
        """
        Get the linkage of this Decl node
        """
        ...

    def linkage_name(self) -> typing.Optional[AstNode]:
        """
        Get the linkage name of this Decl node
        """
        ...

    def visibility(self) -> str:
        """
        Get the visibility of this Decl node
        """
        ...


class TupleDecl(Decl):
    def decls(self) -> typing.Iterator[Decl]:
        """
        Get the declarations for this TupleDecl node
        """
        ...

    def init_expression(self) -> typing.Optional[AstNode]:
        """
        Get the init expression of this TupleDecl node
        """
        ...

    def intent_or_kind(self) -> str:
        """
        Get the intent or kind of this TupleDecl node
        """
        ...

    def type_expression(self) -> typing.Optional[AstNode]:
        """
        Get the type expression of this TupleDecl node
        """
        ...


class ForwardingDecl(Decl):
    def expr(self) -> typing.Optional[AstNode]:
        """
        Get the expression of this ForwardingDecl node
        """
        ...


class NamedDecl(Decl):
    def name(self) -> str:
        """
        Get the name of this NamedDecl node
        """
        ...

    def name_location(self) -> Location:
        """
        Get the textual location of the NamedDecl node's name
        """
        ...

    def header_location(self) -> typing.Optional[Location]:
        """
        Get the Location of this NamedDecl node's header
        """
        ...


class EnumElement(NamedDecl):
    def init_expression(self) -> typing.Optional[AstNode]:
        """
        Get the init expression of this EnumElement node
        """
        ...


class Function(NamedDecl):
    def formals(self) -> typing.Iterator[Decl]:
        """
        Get the formals for this Function node
        """
        ...

    def body(self) -> typing.Optional[Block]:
        """
        Get the body for this function
        """
        ...

    def formal(self, arg0: int) -> Decl:
        """
        Get the n'th Formal of this Function node
        """
        ...

    def is_anonymous(self) -> bool:
        """
        Check if this Function node is anonymous
        """
        ...

    def is_inline(self) -> bool:
        """
        Check if this Function node is marked inline
        """
        ...

    def is_method(self) -> bool:
        """
        Check if this Function node is a method
        """
        ...

    def is_override(self) -> bool:
        """
        Check if this Function node is an override
        """
        ...

    def is_parenless(self) -> bool:
        """
        Check if this Function node is parenless
        """
        ...

    def is_primary_method(self) -> bool:
        """
        Check if this Function node is a primary method
        """
        ...

    def kind(self) -> str:
        """
        Get the kind of this Function node
        """
        ...

    def lifetime_clauses(self) -> typing.Iterator[AstNode]:
        """
        Get the lifetime clauses for this Function node
        """
        ...

    def num_formals(self) -> int:
        """
        Get the number of formals for this Function node
        """
        ...

    def return_intent(self) -> str:
        """
        Get the return intent of this Function node
        """
        ...

    def return_type(self) -> typing.Optional[AstNode]:
        """
        Get the return type for this Function node
        """
        ...

    def this_formal(self) -> typing.Optional[Decl]:
        """
        Get the this formal for this Function node
        """
        ...

    def throws(self) -> bool:
        """
        Check if this Function node is marked throws
        """
        ...

    def where_clause(self) -> typing.Optional[AstNode]:
        """
        Get the where clause for this Function node
        """
        ...


class Interface(NamedDecl):
    def stmts(self) -> typing.Iterator[AstNode]:
        """
        Get the statements for this Interface node
        """
        ...

    def formals(self) -> typing.Iterator[AstNode]:
        """
        Get the formals for this Interface node
        """
        ...

    def is_formal_list_explicit(self) -> bool:
        """
        Check if this Interface node has an explicit formal list
        """
        ...


class Module(NamedDecl):
    def kind(self) -> str:
        """
        Get the kind of this Module node
        """
        ...


class ReduceIntent(NamedDecl):
    def op(self) -> AstNode:
        """
        Get the op for this ReduceIntent node
        """
        ...


class VarLikeDecl(NamedDecl):
    def init_expression(self) -> typing.Optional[AstNode]:
        """
        Get the init expression of this VarLikeDecl node
        """
        ...

    def storage_kind(self) -> str:
        """
        Get the storage kind of this VarLikeDecl node
        """
        ...

    def type_expression(self) -> typing.Optional[AstNode]:
        """
        Get the type expression of this VarLikeDecl node
        """
        ...

    def intent(self) -> str:
        """
        Get the intent for this VarLikeDecl node
        """
        ...


class VarArgFormal(VarLikeDecl):
    def count(self) -> typing.Optional[AstNode]:
        """
        Get the count expression of this VarArgFormal node
        """
        ...


class Variable(VarLikeDecl):
    def is_config(self) -> bool:
        """
        Check if this Variable node is a config variable
        """
        ...

    def is_field(self) -> bool:
        """
        Check if this Variable node is a class field variable
        """
        ...

    def kind(self) -> str:
        """
        Get the kind of this Variable node
        """
        ...


class AggregateDecl(TypeDecl):
    def decls_or_comments(self) -> typing.Iterator[AstNode]:
        """
        Get the declarations and comments of this AggregateDecl node
        """
        ...

    def inherit_exprs(self) -> typing.Iterator[AstNode]:
        """
        Get the inherit expressions of this AggregateDecl node
        """
        ...


class AnyType(ChapelType):
    pass
class CStringType(ChapelType):
    pass
class ErroneousType(ChapelType):
    pass
class NilType(ChapelType):
    pass
class NothingType(ChapelType):
    pass
class UnknownType(ChapelType):
    pass
class VoidType(ChapelType):
    pass
class CPtrType(ChapelType):
    pass
class BuiltinType(ChapelType):
    pass
class CFnPtrType(BuiltinType):
    pass
class CVoidPtrType(BuiltinType):
    pass
class OpaqueType(BuiltinType):
    pass
class SyncAuxType(BuiltinType):
    pass
class TaskIdType(BuiltinType):
    pass
class AnyComplexType(BuiltinType):
    pass
class AnyEnumType(BuiltinType):
    pass
class AnyImagType(BuiltinType):
    pass
class AnyIntType(BuiltinType):
    pass
class AnyIntegralType(BuiltinType):
    pass
class AnyIteratorClassType(BuiltinType):
    pass
class AnyIteratorRecordType(BuiltinType):
    pass
class AnyThunkRecordType(BuiltinType):
    pass
class AnyNumericType(BuiltinType):
    pass
class AnyOwnedType(BuiltinType):
    pass
class AnyPodType(BuiltinType):
    pass
class AnyRealType(BuiltinType):
    pass
class AnyRecordType(BuiltinType):
    pass
class AnySharedType(BuiltinType):
    pass
class AnyUintType(BuiltinType):
    pass
class AnyUninstantiatedType(BuiltinType):
    pass
class AnyUnionType(BuiltinType):
    pass
class DeclaredType(ChapelType):
    pass
class ClassType(DeclaredType):
    pass
class EnumType(DeclaredType):
    pass
class ExternType(DeclaredType):
    pass
class FunctionType(DeclaredType):
    pass
class ArrayType(CompositeType):
    pass
class ManageableType(CompositeType):
    pass
class BasicClassType(ManageableType):
    pass
class AnyClassType(ManageableType):
    pass
class DomainType(CompositeType):
    pass
class RecordType(CompositeType):
    pass
class TupleType(CompositeType):
    pass
class UnionType(CompositeType):
    pass
class PrimitiveType(ChapelType):
    pass
class BoolType(PrimitiveType):
    pass
class ComplexType(PrimitiveType):
    pass
class ImagType(PrimitiveType):
    pass
class IntType(PrimitiveType):
    pass
class RealType(PrimitiveType):
    pass
class UintType(PrimitiveType):
    pass
class EmptyStmt(AstNode):
    pass
class ErroneousExpression(AstNode):
    pass
class Let(AstNode):
    pass
class Block(SimpleBlockLike):
    pass
class Defer(SimpleBlockLike):
    pass
class Sync(SimpleBlockLike):
    pass
class Coforall(IndexableLoop):
    pass
class Forall(IndexableLoop):
    pass
class Foreach(IndexableLoop):
    pass
class Literal(AstNode):
    pass
class BytesLiteral(StringLikeLiteral):
    pass
class CStringLiteral(StringLikeLiteral):
    pass
class StringLiteral(StringLikeLiteral):
    pass
class Tuple(Call):
    pass
class Zip(Call):
    pass
class MultiDecl(Decl):
    pass
class TypeQuery(NamedDecl):
    pass
class Formal(VarLikeDecl):
    pass
class TaskVar(VarLikeDecl):
    pass
class TypeDecl(NamedDecl):
    pass
class Enum(TypeDecl):
    pass
class Class(AggregateDecl):
    pass
class Record(AggregateDecl):
    pass
class Union(AggregateDecl):
    pass
class ComplexParam(Param):
    pass
class NoneParam(Param):
    pass
class RealParam(Param):
    pass
class UintParam(Param):
    pass

